#ifndef _winapi_c_any_rich_edit_h_
#define _winapi_c_any_rich_edit_h_
//---------------------------------------------------------------------------

// "base.h" must be the first header file
#include "base.h"
#include "AnyWindow.h"
#include <richedit.h>


INT   AnyRichEdit_ExGetSelPos(HWND hEd, INT* pnStartPos /* = NULL */, INT* pnEndPos /* = NULL */);
void  AnyRichEdit_ExLimitText(HWND hEd, INT nMaxLength);
INT   AnyRichEdit_ExLineFromChar(HWND hEd, INT nCharacterIndex);
void  AnyRichEdit_ExSetSelPos(HWND hEd, INT nStartPos, INT nEndPos);
INT   AnyRichEdit_FirstVisibleCharIndex(HWND hEd);
INT   AnyRichEdit_FirstVisibleLine(HWND hEd);
TCHAR AnyRichEdit_GetCharAt(HWND hEd, INT nPos);
BOOL  AnyRichEdit_GetEditRect(HWND hEd, RECT* lpRect); // always use it instead of GetClientRect!!!
DWORD AnyRichEdit_GetEventMask(HWND hEd);
INT   AnyRichEdit_GetFirstVisibleLine(HWND hEd);
INT   AnyRichEdit_GetLine(HWND hEd, INT nLine, TCHAR* lpTextBuf, WORD wTextBufSize);
INT   AnyRichEdit_GetLineCount(HWND hEd);
INT   AnyRichEdit_GetTextAt(HWND hEd, INT nPos, INT nLen, TCHAR* lpText);
INT   AnyRichEdit_LastVisibleCharIndex(HWND hEd);
INT   AnyRichEdit_LastVisibleLine(HWND hEd);
INT   AnyRichEdit_LineIndex(HWND hEd, INT nLine); // returns index of the 1st character
INT   AnyRichEdit_LineLength(HWND hEd, INT nCharacterIndex);
void  AnyRichEdit_ReplaceSelText(HWND hEd, const TCHAR* cszText, BOOL bCanUndo /* = FALSE */);
BOOL  AnyRichEdit_SetCharFormat(HWND hEd, DWORD dwMask, DWORD dwEffects,
        COLORREF color /* = RGB(0,0,0) */, DWORD dwOptions /* = SCF_SELECTION */);
DWORD AnyRichEdit_SetEventMask(HWND hEd, DWORD nEventMask);

#ifdef any_ctrl_enable_w_members
INT   AnyRichEdit_ExGetSelPosW(HWND hEd, INT* pnStartPos /* = NULL */, INT* pnEndPos /* = NULL */);
void  AnyRichEdit_ExLimitTextW(HWND hEd, INT nMaxLength);
INT   AnyRichEdit_ExLineFromCharW(HWND hEd, INT nCharacterIndex);
void  AnyRichEdit_ExSetSelPosW(HWND hEd, INT nStartPos, INT nEndPos);
INT   AnyRichEdit_FirstVisibleCharIndexW(HWND hEd);
INT   AnyRichEdit_FirstVisibleLineW(HWND hEd);
WCHAR AnyRichEdit_GetCharAtW(HWND hEd, INT nPos);
DWORD AnyRichEdit_GetEventMaskW(HWND hEd);
INT   AnyRichEdit_GetFirstVisibleLineW(HWND hEd);
INT   AnyRichEdit_GetLineW(HWND hEd, INT nLine, WCHAR* lpTextBuf, WORD wTextBufSize);
INT   AnyRichEdit_GetLineCountW(HWND hEd);
INT   AnyRichEdit_GetTextAtW(HWND hEd, INT nPos, INT nLen, WCHAR* lpText);
INT   AnyRichEdit_LastVisibleCharIndexW(HWND hEd);
INT   AnyRichEdit_LastVisibleLineW(HWND hEd);
INT   AnyRichEdit_LineIndexW(HWND hEd, INT nLine); // returns index of the 1st character
INT   AnyRichEdit_LineLengthW(HWND hEd, INT nCharacterIndex);
void  AnyRichEdit_ReplaceSelTextW(HWND hEd, const WCHAR* cszText, BOOL bCanUndo /* = FALSE */);
BOOL  AnyRichEdit_SetCharFormatW(HWND hEd, DWORD dwMask, DWORD dwEffects,
        COLORREF color /* = RGB(0,0,0) */, DWORD dwOptions /* = SCF_SELECTION */);
DWORD AnyRichEdit_SetEventMaskW(HWND hEd, DWORD nEventMask);
#endif


//---------------------------------------------------------------------------
#endif
